#
# sgpk03.rb
#
# $Id: sgpk03.rb,v 1.1 2000/11/21 03:02:07 keiko Exp $
#

require "narray"
require "dcl"

include DCL
include NMath

n = 41
x = NArray.sfloat(n)
y = NArray.sfloat(n)

#-- data ---
dt = 4.0* 3.14159 / (n-1)
x = x.indgen * (1.0/(n-1))
y = y.indgen * dt
y = sin(y) * 0.15
#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

#----------------------------- page 1 ---------------------------------
sgfrm

sgswnd(0.0, 1.0, -0.8, 0.2)
sgsvpt(0.15, 0.85, 0.1, 0.9)
sgstrn(1)
sgstrf
slpvpr(1)
sgplu(n, x, y)                   # <-- 1

sgswnd(0.0, 1.0, -0.7, 0.3)
sgstrf
sgspli(2)                        # <-- line index 
sgplu(n, x, y)                   # <-- 2

sgswnd(0.0, 1.0, -0.6, 0.4)
sgstrf
sgspli(3)                        # <-- line index 
sgplu(n, x, y)                   # <-- 3

sgswnd(0.0, 1.0, -0.4, 0.6)
sgstrf
sgsplt(2)                        # <--linetype()
sgplu(n, x, y)                   # <-- 4

sgswnd(0.0, 1.0, -0.3, 0.7)
sgstrf
sgsplt(3)                        # <--linetype()
sgplu(n, x, y)                   # <-- 5

sgswnd(0.0, 1.0, -0.2, 0.8)
sgstrf
sgsplt(4)                        # <--linetype()
sgplu(n, x, y)                   # <-- 6

#----------------------------- page 2 ---------------------------------
sgfrm

sgswnd(0.0, 1.0, -0.8, 0.2)
sgsvpt(0.15, 0.85, 0.1, 0.9)
sgstrn(1)
sgstrf
slpvpr(1)

sgrset('bitlen', 0.006)          # <-- Ĺѹ
sgsplt(4)
sgplu(n, x, y)                   # <-- 1

sgswnd(0.0, 1.0, -0.6, 0.4)
sgstrf
sgspli(2)

itype = '0b1111111100100100'.oct # <-- ѥ
sgsplt(itype)                    # <-- ѥ
sgplu(n, x, y)                   # <-- 2

sgswnd(0.0, 1.0, -0.4, 0.6)
sgstrf
sgiset('NBITS', 32)
itype = '0b10010010011111000111110001111100'.oct - ("0b1" + "0"*32).oct
sgsplt(itype)
sgplu(n, x, y)

sgswnd(0.0, 1.0, -0.2, 0.8)
sgstrf
sgspli(1)
sgsplt(1)

n1=n/4
y[n1-2] = 999.0                  # <-- »
y[n1-1] = 999.0
y[n1  ] = 999.0

n2=n1*3
y[n2-2] = 999.0
y[n2  ] = 999.0

gllset('LMISS', true)
sgplu(n, x, y)                   # <-- 4

sgcls

